<?php

/**
 This project has been generated by worker generator
 has been made by fahmi sulaiman
 sulaimanfahmi@gmail.com
 check out my github @dekaulitz
 */

namespace App\Http\Controllers\Administrator;

use App\Exceptions\DefaultException;
use App\Http\Base\BaseController;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use App\Http\Services\UsersService;
use App\Http\Validators\UsersValidator;
use App\Http\Services\KapalService;
use App\Http\Services\RolesService;
use App\Http\Services\LokasiitemService;
use App\Http\Services\ActivitylogService;

class UsersController extends BaseController
{
	protected $baseService;
	protected $validator;
	private $kapal;
	private $roles;
	private $lokasiitem;
	private $activityLog;

	/**
      Users constructor.
	 */
	public function __construct()
	{
		parent::__construct();
		$this->baseService = new UsersService();
		$this->validator = new UsersValidator();
		$this->kapal = new KapalService();
		$this->roles = new RolesService();
		$this->lokasiitem = new LokasiitemService();
		$this->activityLog = new ActivitylogService();
	}


	/**
	 * @param Request $request
	 * @return \Illuminate\Http\RedirectResponse
	 * @throws DefaultException
	 */
	public function store(Request $request)
	{
		$this->validator->beforeInsert($request->all());
		if ($this->validator->hasError())
			return $this->validator->validateView();
		DB::beginTransaction();
		try {
			$ID = $this->baseService->store($request->all());

			$auth = json_decode($request->session()->get('auth'));
			$activityLog = [
				"username" => $auth->username,
				"urlTransaksi" => "users",
				"namaTransaksi" => "Users",
				"date" => date("Y-m-d H:i:s"),
				"activity" => "CREATE",
				"refId" => $ID,
				"date_updated" => date("Y-m-d H:i:s"),
				"kapalId" => $auth->kapalId,
				"deskripsi" => $auth->name . " just <b>created</b> new User <a href=\"" . url("administrator/users/" . $ID) . "\">here</a>"
			];
			$this->activityLog->store($activityLog);

			DB::commit();
			// $this->sync();
			return redirect()->to("administrator/users")->with("successMessages", "Data has been created");
		} catch (\Exception $e) {
			DB::rollBack();
			throw new DefaultException($e->getMessage());
		}
	}

	/**
	 *  @param Request $request
	 *  @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
	 */
	public function paging(Request $request)
	{
		$this->data["header"] = [
			"id" => "ID", "username" => "Username", "kapalId" => "Kapal", "roleId" => "Role", "name" => "Name"
			// ,"password"=>"password"
		];
		$this->data["criteria"] = [
			"id" => "ID", "username" => "Username", "kapalId" => "Kapal", "roleId" => "Role", "name" => "Name"
			// ,"password"=>"password"
		];
		$this->data["ordering"] = [
			"username:asc" => "Username &uarr;", "username:desc" => "Username &darr;", "name:asc" => "Name &uarr;", "name:desc" => "Name &darr;", "nrp:asc" => "NRP &uarr;", "nrp:desc" => "NRP &darr;"
			// ,"password:asc"=>"password"
		];
		$this->data["kapals"] = $this->kapal->getList($request);
		$this->data["roles"] = $this->roles->getList($request);
		$this->data["userss"] = $this->baseService->paging($request);
		return view("modules.users.users_index", $this->data);
	}

	/**
	 *  @param $id
	 *  @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
	 */
	public function edit(Request $request, $id)
	{
		$auth = json_decode($request->session()->get('auth'));
		if ($auth->aplikasi == "HO") {
			$this->data["kapals"] = $this->kapal->getList($request);
			$this->data["roles"] = $this->roles->getList($request);
			$this->data["lokasiitems"] = $this->lokasiitem->getList($request);
			$this->data["users"] = $this->baseService->show($id);
			return view("modules.users.users_edit", $this->data);
		} else {
			return redirect()->to("administrator/users")->with("errMessage", "Sorry, you don't have access to this page!");
		}
	}


	/**
	 * @param Request $request
	 * @param $id
	 * @return \Illuminate\Http\RedirectResponse
	 * @throws DefaultException
	 */
	public function update(Request $request, $id)
	{
		$this->validator->beforeUpdate($request->all(), $id);
		if ($this->validator->hasError()) {
			return $this->validator->validateView();
		}
		DB::beginTransaction();
		try {
			$this->baseService->update($id, $request->all());

			$auth = json_decode($request->session()->get('auth'));
			$activityLog = [
				"username" => $auth->username,
				"urlTransaksi" => "users",
				"namaTransaksi" => "Users",
				"date" => date("Y-m-d H:i:s"),
				"activity" => "UPDATE",
				"refId" => $id,
				"date_updated" => date("Y-m-d H:i:s"),
				"kapalId" => $auth->kapalId,
				"deskripsi" => $auth->name . " just <b>updated</b> User <a href=\"" . url("administrator/users/" . $id) . "\">here</a>"
			];
			$this->activityLog->store($activityLog);

			DB::commit();
			// $this->sync();
			return redirect()->to("administrator/users")->with("successMessages", "Data has been updated");
		} catch (\Exception $e) {
			DB::rollBack();
			throw new DefaultException($e->getMessage());
		}
	}

	/**
	 *  @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
	 */
	public function create(Request $request)
	{
		$auth = json_decode($request->session()->get('auth'));
		if ($auth->aplikasi == "HO") {
			$this->data["kapals"] = $this->kapal->getList($request);
			$this->data["roles"] = $this->roles->getList($request);
			return view("modules.users.users_create", $this->data);
		} else {
			return redirect()->to("administrator/users")->with("errMessage", "Sorry, you don't have access to this page!");
		}
	}

	/**
	 *  @param $id
	 *  @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
	 */
	public function show($id)
	{
		$this->data["users"] = $this->baseService->show($id);
		return view("modules.users.users_show", $this->data);
	}

	/**
	 *  index function that get all data from database by default
	 *  @param $ids
	 *  @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
	 */
	public function destroy($ids)
	{
		$this->baseService->delete($ids);
		return redirect()->back()->with("successMessages", "Data has been deleted");
	}

	public function setpassword($id)
	{
		$this->data["users"] = $this->baseService->show($id);
		return view("modules.users.users_setpassword", $this->data);
	}

	public function updatepassword(Request $request, $id)
	{
		$this->validator->beforeUpdatePassword($request->all(), $id);
		if ($this->validator->hasError()) {
			return $this->validator->validateView();
		}
		DB::beginTransaction();
		try {
			$this->baseService->updatePassword($id, $request->all());

			$auth = json_decode($request->session()->get('auth'));
			$activityLog = [
				"username" => $auth->username,
				"urlTransaksi" => "users/setpassword",
				"namaTransaksi" => "User's Password",
				"date" => date("Y-m-d H:i:s"),
				"activity" => "UPDATE",
				"refId" => $id,
				"date_updated" => date("Y-m-d H:i:s"),
				"kapalId" => $auth->kapalId,
				"deskripsi" => $auth->name . " just <b>updated</b> User's Password <a href=\"" . url("administrator/users/setpassword/" . $id) . "\">here</a>"
			];
			$this->activityLog->store($activityLog);

			DB::commit();
			// $this->sync();
			return redirect()->to("administrator/users")->with("successMessages", "Data has been updated");
		} catch (\Exception $e) {
			DB::rollBack();
			throw new DefaultException($e->getMessage());
		}
	}

	public function activation(Request $request)
	{
		$input = $request->all();
		$userID = $input["userID"];
		$activateCode = $input["activateCode"];

		$data = $this->baseService->activation($activateCode, $userID);
		echo json_encode($data);
	}

	public function getListRoles(Request $request)
	{
		$data = $this->roles->getList($request);
		echo json_encode($data);
	}

	public function getListSubInv(Request $request)
	{
		$data = $this->lokasiitem->getList($request);
		echo json_encode($data);
	}
}
